Subject: Re: I can't get contributors for my C project. Can you help?

From: Bagas Sanjaya <[email-masked]>
Date: Sat, 7 Oct 2023 15:56:43 +0700

On Fri, Oct 06, 2023 at 07:18:20PM +0000, [email-masked] wrote:
> Dear RMS;
> 
> I've read that you are both a lisp and C developer. I cannot get any contributors for the longstanding C 3d engine I work on as part of my fully-free-software (including media) 3d game/architecture project. I've been working on it alone for 10 years but now have branched into supporting more 3d file types and can't do that alone.
> 
> I've gone to "opensource" forums and gotten banned every single time for asking for help. Every single time. The message gets deleted. This is extremely difficult: it's not like 20 years ago when communication was free. Obvs the "opensource" community is no longer interested in any collaboration or development.
> 
> The reason I wanted to find more contributors, is that I recently (last 2 years) programmed more file format support myself (wolfenstine:enemyterritory bsp support) and extended and fixed support for existing formats (obj file support for use as maps, and support for minetest and minecraft object exports as maps directly into the game, and BZFlag exported obj as maps (these didn't work at all before: now they do (bzflag and the engine previously had different opinions on what an obj file was mathmatically))). That opened up 600 3d maps with the bsp work, and then 1000s of obj files with the obj_to_mc work. So I felt I was on a roll. Sketchfab was "opened up" and lots of free-software-licensed terrain and such were easily used from there. It was nice. I wanted to keep going.
> 
> I thought it might be possible to get unreal 97 and unreal tournament 99 3d map formats working: as there are tons of maps there and I used to make little 3d worlds using that format. The two main formats here are .t3d ; an ascii format (like obj) but which requires CSG math, and .unr : a binary format which pre-compiles the csg math down to vertex and face info; but is more complex a format.
> 
> I found free software projects in C++ that tackle each (my project is in C): that could be used to learn the math. The t3d one even does the csg work. I just need to plead to you: please: I need contributors now. I did everything I could in these last 10 years under free-software licenses: made lots of maps, made tons of 3d models, made textures, game code (QuakeC), engine code (C). I extended the engine to beable to address up to 4 million entities, I programmed procedural map generation routines that allow creating cities out of nothing. I modeled tons of buildings, with both interiors, and level-of-detail models; so you can explore cities and not just go on the ourside of buildings. I modeled vehicles, added vehicles, programmed vehicles. I added 200 wps, and building code so players can do whatever they want in this 3d platform: from architecture, city building, town building, to fighting eachother, or racing cars, helicopters, to putting out fires. I've made music for it. All free software licensed.
> 
> I just cannot get contributors. Every single place I post a plea for help the thing is banned and deleted.
> The only thing I've gotten is people trying to take down the project because they're mad I dared asked for file format help or for another programmer to join.
> Can you and the free software people help?
> 
> I've asked "opensource" they sad "banned" and "scram"
> So I turn to you. It's in C. Your language.
> Please.
> I beg of you.
> 
> I can't do these file formats alone.
> 
> ----------
> Here's a ticket of the issue: sourceforge.net/p/chaosesqueanthology/tickets/2/   ( #2 Please help with .t3d and .unr loading (3d world file types) )
> Here's a git of the source code: sourceforge.net/p/chaosesqueanthology/code-t3d_attempt_engine/ci/master/tree/
> And here is a tarball of the source code: sourceforge.net/p/chaosesqueanthology/discussion/general/thread/72c4ff80c1/f23d/attachment/darkplaces_workingon_sep_06_2023_aug19cde_SOURCEONLY.tar.gz
> 
> I started in model_brush.c , added in a new file handler: void
> T3d_Attempt_Which_will_Mod_OBJ_Load(dp_model_t mod, void buffer,
> void *bufferend)
> and got it printing the vertex info of the t3d stuff.
> 
> I found 2 free software projects that handle (in C++) the two file formats, and I asked them for help but no response: (.t3d) T3d2Map(C++): github.com/mildred/t3d2map (.unr) UShock(C++): sourceforge.net/projects/ushock/
> 
> So I just need help here.
> I cannot do this part of the engine coding alone.
> I know I did other formats: but it was alot of hacking and they weren't too different.
> But here: it would take me years since I'm a hacker (at best) and not a professional file programmer.
> 
> Please help. Is there anywhere I can ask? Everywhere seems shutdown, filterd, and blocked, and very very unfriendly to any C dev requests.
> Hope you get well soon.
> 
> 

Seems like you have a userspace application issue. This ML (LKML) is for
Linux kernel development, not userspace. But if you want to contribute to
the kernel, you can apply for Outreachy program (see [1] for the announcement).

Bye!

[1]: https://lore.kernel.org/outreachy/alpine.DEB.2.22.394.2310020741050.3166@hadrien/

-- 
An old man doll... just what I always wanted! - Clara